<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for domesticShipmentDataListType StructType
 * @subpackage Structs
 */
class DomesticShipmentDataListType extends AbstractStructBase
{
    /**
     * The domesticShipmentData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DomesticShipmentDataType[]
     */
    public $domesticShipmentData;
    /**
     * Constructor method for domesticShipmentDataListType
     * @uses DomesticShipmentDataListType::setDomesticShipmentData()
     * @param \StructType\DomesticShipmentDataType[] $domesticShipmentData
     */
    public function __construct(array $domesticShipmentData = array())
    {
        $this
            ->setDomesticShipmentData($domesticShipmentData);
    }
    /**
     * Get domesticShipmentData value
     * @return \StructType\DomesticShipmentDataType[]|null
     */
    public function getDomesticShipmentData()
    {
        return $this->domesticShipmentData;
    }
    /**
     * This method is responsible for validating the values passed to the setDomesticShipmentData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDomesticShipmentData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDomesticShipmentDataForArrayConstraintsFromSetDomesticShipmentData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $domesticShipmentDataListTypeDomesticShipmentDataItem) {
            // validation for constraint: itemType
            if (!$domesticShipmentDataListTypeDomesticShipmentDataItem instanceof \StructType\DomesticShipmentDataType) {
                $invalidValues[] = is_object($domesticShipmentDataListTypeDomesticShipmentDataItem) ? get_class($domesticShipmentDataListTypeDomesticShipmentDataItem) : sprintf('%s(%s)', gettype($domesticShipmentDataListTypeDomesticShipmentDataItem), var_export($domesticShipmentDataListTypeDomesticShipmentDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The domesticShipmentData property can only contain items of type \StructType\DomesticShipmentDataType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set domesticShipmentData value
     * @throws \InvalidArgumentException
     * @param \StructType\DomesticShipmentDataType[] $domesticShipmentData
     * @return \StructType\DomesticShipmentDataListType
     */
    public function setDomesticShipmentData(array $domesticShipmentData = array())
    {
        // validation for constraint: array
        if ('' !== ($domesticShipmentDataArrayErrorMessage = self::validateDomesticShipmentDataForArrayConstraintsFromSetDomesticShipmentData($domesticShipmentData))) {
            throw new \InvalidArgumentException($domesticShipmentDataArrayErrorMessage, __LINE__);
        }
        $this->domesticShipmentData = $domesticShipmentData;
        return $this;
    }
    /**
     * Add item to domesticShipmentData value
     * @throws \InvalidArgumentException
     * @param \StructType\DomesticShipmentDataType $item
     * @return \StructType\DomesticShipmentDataListType
     */
    public function addToDomesticShipmentData(\StructType\DomesticShipmentDataType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DomesticShipmentDataType) {
            throw new \InvalidArgumentException(sprintf('The domesticShipmentData property can only contain items of type \StructType\DomesticShipmentDataType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->domesticShipmentData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DomesticShipmentDataListType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
